<?php

// Modul-Output

if (OOAddon::isAvailable('mp_availability_calendar'))
{
  // show calendar for the selected object
  $object_id = "REX_VALUE[1]";

  if ($object_id > 0) {

    // setting the locale for date output with strftime, etc
    // this have to be adjusted to your php installation
    // in particular the locale strings are platform dependent
    // in my installation this is only necessary for the frontend
    // in the backend the locale is set automatically
    switch ($REX['CUR_CLANG'])
    {
      case 1:  // englisch
        if (strstr($REX['LANG'], 'utf8')) {
          $locale = setlocale(LC_TIME, 'en_GB.UTF8', 'en_UK.UTF8', 'en_US.UTF8', 'en_GB', 'en_UK', 'en_US', 'en_EN', 'en', 'english');
        } else {
          $locale = setlocale(LC_TIME, 'en_GB', 'en_UK', 'en_US', 'en_EN', 'en', 'english');
        }
        break;
      case 0:  // deutsch
      default:
        if (strstr($REX['LANG'], 'utf8')) {
          $locale = setlocale(LC_TIME, 'de_DE.UTF8', 'de_DE.UTF-8', 'de_DE', 'de', 'deu_deu', 'deu', 'germany');
        } else {
          $locale = setlocale(LC_TIME, 'de_DE', 'de', 'deu_deu', 'deu', 'germany');
        }
    }

    // number of months to show on one page
    $month_to_show = "REX_VALUE[2]";

    // how many months to show in a row
    $month_per_row = "REX_VALUE[3]";

    // should a navigation be displayed
    $show_nav = "REX_VALUE[4]";

    // the labels for the legend
    $labels = array();
    if ("REX_VALUE[5]" != '')
    {
      $labels['none'] = "REX_VALUE[5]";
    }
    if ("REX_VALUE[6]" != '')
    {
      $labels['all'] = "REX_VALUE[6]";
    }
    if ("REX_VALUE[7]" != '')
    {
      $labels['am'] = "REX_VALUE[7]";
    }
    if ("REX_VALUE[8]" != '')
    {
      $labels['pm'] = "REX_VALUE[8]";
    }

    // initialize date parameters
    $date = rex_request('date', 'string', date('Y-m-d'));
    $year = rex_request('year', 'string', date('Y', strtotime($date)));
    $month = rex_request('month', 'string', date('m', strtotime($date)));

    // create instance of calendar class
    require_once $REX['INCLUDE_PATH'].'/addons/mp_availability_calendar/classes/class.calendar.inc.php';
    $calendar = new mp_availability_calendar($object_id, $date, $year, $month);
    $calendar->setOption('week_start', $REX['ADDON']['mp_availability_calendar']['week_start_day']);
    //$calendar->setOption('table_six_rows', true);

    // set clearer for frontend/backend
    if ($REX['REDAXO'])
    {
      $clear = '<div class="rex-clearer"></div>';
    }
    else
    {
      $clear = '<div class="clear"></div>';
    }

    // show navigation ?
    if ($show_nav == 1)
    {
      echo $calendar->getNav($month_to_show);
      echo $clear;
    }
    else
    {
      echo $calendar->getPeriod($month_to_show);
      echo $clear;
    }

    // show the calendar
    for ($i = 0; $i < $month_to_show; $i++)
    {
      echo $calendar->getMonthView($year, $month + $i);
      if (($i % $month_per_row + 1) == $month_per_row) echo $clear;
    }

    // show the legend
    if (count($labels) > 0)
    {
      echo $calendar->getLegend($labels);
      echo $clear;
    }

  }
  else
  {
    // no object selected
    echo rex_warning('Kein Objekt ausgewhlt!');
  }

}
else
{
  // addon is not available
  echo rex_warning('Dieses Modul bentigt das "mp_availability_calendar" Addon!');

}

?>