<?php
/**
 * Belegungskalendar Addon
 * @author bade[at]maple-park[dot]de Heinz Bade
 * @author <a href="http://www.maple-park.de">www.maple-park.de</a>
 * @package redaxo 4.3
 * @version $Id: calendar.inc.php,v 1.0 2010/12/08 16:05:00 elektra Exp $
 */

// number of months to show on one page
$month_to_show = $REX['ADDON'][$page]['month_to_show'];

// initialize request parameters
$call_by = rex_request('call_by', 'string');
$object_id = rex_request('object_id', 'integer', 0);
$date = rex_request('date', 'string', date('Y-m-d'));
$year = rex_request('year', 'string', date('Y', strtotime($date)));
$month = rex_request('month', 'string', date('m', strtotime($date)));
$func = rex_request('func', 'string');
$state = rex_request('state', 'string');

// initialize a database connection
$sql = rex_sql::factory();
//$sql->setDebug(true);


if ($call_by == 'ajax') {

  // clean all active output buffers and start a new one
  ob_end_clean();
  ob_start('ajax');

  // send header
  header('Content-Type: text/plain');
  header('Cache-Control: no-cache');

  // look up in database if the day is already booked
  $sql->setTable($REX['TABLE_PREFIX'].'mp_availability_calendar');
  $sql->setWhere("object_id = ". $object_id." AND booked_day = '". $date ."'");
  $sql->select('id, state');

  // if in database
  if ($sql->getRows() > 0) {
    $db_id = $sql->getValue('id');
    $db_state = $sql->getValue('state');
    if (($state == 'am' && ($db_state == 'all' || $db_state == 'pm')) || ($state == 'pm' && ($db_state == 'all' || $db_state == 'am'))) {
      // -> update the entry
      $sql->setTable($REX['TABLE_PREFIX'].'mp_availability_calendar');
      $sql->setWhere('id = '. $db_id);
      $sql->setValue('state', $state);
      // -> send as response the new css-class
      echo $sql->update('booked-'.$state);
    }
    else {
      // -> delete the entry
      $sql->setTable($REX['TABLE_PREFIX'].'mp_availability_calendar');
      $sql->setWhere('id = '. $db_id);
      // -> send as response "deleted"
      echo $sql->delete('deleted');
    }
  }
  // else (if not in database)
  else {
    // -> add the entry
    $sql->setTable($REX['TABLE_PREFIX'].'mp_availability_calendar');
    $sql->setValue('object_id', $object_id);
    $sql->setValue('booked_day', $date);
    $sql->setValue('state', $state);
    // -> send as response the new css-class
    echo $sql->insert('booked-'.$state);
  }
  // if error
  if ($sql->hasError()) {
    // -> send as response "error"
    // ToDo: send more informations about the error
    echo 'error';
  }
  $sql->flush();

  // send the content of the output buffer
  ob_end_flush();
  exit();

}


// select the object
$select_object = new rex_select();
$select_object->setName('object_id');
$select_object->setId('object_id');
$select_object->setSize(1);
$select_object->setAttribute('onchange', 'this.form.submit()');
$objects = $sql->getArray('SELECT `name`, `id` FROM `'.$REX['TABLE_PREFIX'].'mp_availability_calendar_objects` WHERE `status` = 1');
foreach ($objects as $object) {
  $select_object->addOption($object['name'], $object['id']);
}
if ($object_id == 0 && count($objects) > 0) {
  $object_id = $objects[0]['id'];
}
$select_object->setSelected($object_id);
$sql->flush();


// create instance of calendar class
require_once $REX['INCLUDE_PATH'].'/addons/mp_availability_calendar/classes/class.calendar.inc.php';
$calendar = new mp_availability_calendar($object_id, $date, $year, $month);
$calendar->setOption('week_start', $REX['ADDON'][$page]['week_start_day']);
$calendar->setEditMode();


// check if there are objects
if (count($objects) < 1) {
  echo rex_warning($I18N->msg('availability_calendar_first_create_objects'));
}
// show the calendar
else {
?>

<div class="rex-addon-output">
  <h2 class="rex-hl2"><?php echo $I18N->msg('availability_calendar_select_object'); ?></h2>
  <div class="rex-form">
    <form action="index.php" method="post">
      <fieldset class="rex-form-col-1">
        <div class="rex-form-wrapper">
          <input type="hidden" name="page" value="mp_availability_calendar" />
          <input type="hidden" name="subpage" value="calendar" />
          <input type="hidden" name="func" value="select_object" />
          <div class="rex-form-row">
            <p class="rex-form-select">
              <label for="object_id"><?php echo $I18N->msg('availability_calendar_label_object'); ?></label>
              <?php $select_object->show(); ?>
            </p>
          </div>
        </div>
      </fieldset>
    </form>
  </div>
  <div class="rex-clearer"></div>
  <h2 class="rex-hl2"><?php echo $I18N->msg('availability_calendar_edit_booked_days'); ?></h2>
  <div class="rex-addon-content">
    <?php echo $calendar->getNav($month_to_show); ?>
    <div class="rex-clearer"></div>
    <?php
      for ($i = 0; $i < $month_to_show; $i++) {
        echo $calendar->getMonthView($year, $month + $i);
        if ($i % 3 == 2) echo '<div class="rex-clearer"></div>';
      }
    ?>
    <div class="rex-clearer"></div>
    <div class="legend">
      <h3><?php echo $I18N->msg('availability_calendar_legend'); ?></h3>
      <dl class="booking-states">
        <dt class="booked-none"></dt><dd><?php echo $I18N->msg('availability_calendar_booked_none'); ?></dd>
        <dt class="booked-am"></dt><dd><?php echo $I18N->msg('availability_calendar_booked_am'); ?></dd>
        <dt class="booked-pm"></dt><dd><?php echo $I18N->msg('availability_calendar_booked_pm'); ?></dd>
        <dt class="booked-all"></dt><dd><?php echo $I18N->msg('availability_calendar_booked_all'); ?></dd>
      </dl>
      <p class="instructions"><?php echo $I18N->msg('availability_calendar_instructions'); ?></p>
      <div class="rex-clearer"></div>
    </div>
  </div>
  <div class="rex-addon-footer">
  </div>
</div>

<?php
}
?>