<?php
/**
 * Belegungskalendar Addon
 * @author bade[at]maple-park[dot]de Heinz Bade
 * @author <a href="http://www.maple-park.de">www.maple-park.de</a>
 * @package redaxo 4.3
 * @version $Id: objects.inc.php,v 1.1 2011/02/23 14:54:00 elektra$
 */

//------------------------------> Parameter
$func = rex_request('func', 'string');
$id = rex_request('id', 'int', 0);
$mode = rex_request('mode', 'string');


//------------------------------> in der Listenansicht Status ndern
if ($func == 'status')
{
  $status = $mode == 'publish' ? 1 : 0;
  $sql = new rex_sql();
  $sql->setTable($REX['TABLE_PREFIX'].'mp_availability_calendar_objects');
  $sql->setValue('status', $status);
  $sql->setWhere('id = '. $id);
  echo rex_info($sql->update($I18N->msg('availability_calendar_status_changed')));
  $func = '';
}


//------------------------------> in der Listenansicht Eintrag lschen
if ($func == 'delete')
{
  $sql = new rex_sql();
  $sql->setTable($REX['TABLE_PREFIX'].'mp_booking_schedule');
  $sql->setWhere('object_id = '. $id);
  $sql->delete();
  $sql->flush();
  $sql->setTable($REX['TABLE_PREFIX'].'mp_booking_objects');
  $sql->setWhere('id = '. $id);
  echo rex_info($sql->delete($I18N->msg('availability_calendar_object_deleted')));
  $func = '';
}


//------------------------------> Eintragsliste
if ($func == '')
{
  $list = rex_list::factory('SELECT `id`, `name`, `status` FROM `'.$REX['TABLE_PREFIX'].'mp_availability_calendar_objects`');

  $imgHeader = '<a href="'. $list->getUrl(array('func' => 'add')) .'" title="'.$I18N->msg('availability_calendar_add_object').'"><img src="media/add.gif" alt="'.$I18N->msg('add_object').'" /></a>';

  $list->addColumn(
        $imgHeader,
        '<img src="media/document.gif" alt="Details" />',
        0,
        array('<th class="rex-icon">###VALUE###</th>', '<td class="rex-icon">###VALUE###</td>')
        );
  $list->setColumnParams($imgHeader, array('func' => 'edit', 'id' => '###id###'));

  $list->setColumnLabel('id', 'ID');

  $list->setColumnLabel('name', 'Name');
  $list->setColumnParams('name', array('func' => 'edit', 'id' => '###id###'));

  $list->setColumnLabel('status', 'Status');
  $list->setColumnParams('status', array('id' => '###id###'));
  $list->addLinkAttribute('status', 'title', $I18N->msg('availability_calendar_change_status'));
  $list->setColumnFormat('status', 'custom',
    create_function(
       '$params',
       '$list = $params["list"];
        if ($list->getValue("status") == "1") $params = array("func" => "status", "mode" => "unpublish");
        else $params = array("func" => "status", "mode" => "publish");
        return $list->getColumnLink("status", $list->getValue("status") != "1" ?
        "<span style=\"color:red;\">'.$I18N->msg('status_offline').'</span>" :
        "<span style=\"color:green;\">'.$I18N->msg('status_online').'</span>",
        $params);'
    )
  );
  $list->show();
}

//------------------------------> Formular
elseif ($func == 'edit' || $func == 'add')
{
  $form = rex_form::factory($REX['TABLE_PREFIX'].'mp_availability_calendar_objects', $I18N->msg('availability_calendar_edit_object'), 'id='.$id, 'post', false);

//  $form->debug = true;

  if ($func == 'edit')
  {
    $form->addParam('id', $id);
  }

  $field =& $form->addTextField('name');
  $field->setLabel($I18N->msg('availability_calendar_label_name'));

  $field =& $form->addTextAreaField('description');
  $field->setLabel($I18N->msg('availability_calendar_label_description'));

  $field =& $form->addSelectField('status');
  $field->setLabel($I18N->msg('availability_calendar_label_status'));
  $select =& $field->getSelect();
  $select->setSize(1);
  $select->addOption($I18N->msg('status_online'), 1);
  $select->addOption($I18N->msg('status_offline'), 0);

  $form->show();

}

?>